-- Copyright (c) 2014, Oracle and/or its affiliates. All rights reserved.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; version 2 of the License.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

-- Contribution by Daniel van Eeden

delimiter //
CREATE PROCEDURE install_jsonudfs ()
SQL SECURITY INVOKER
READS SQL DATA
BEGIN
  DECLARE os CHAR(3);

  SELECT LOWER(LEFT(VARIABLE_VALUE, 3)) AS os FROM information_schema.global_variables where VARIABLE_NAME='version_compile_os' INTO os;

  IF os = 'win' THEN
    CREATE FUNCTION json_valid RETURNS integer SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_search RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_extract RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_replace RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_append RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_remove RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_set RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_merge RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_safe_merge RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_deep_merge RETURNS string SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_contains_key RETURNS integer SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_depth RETURNS INTEGER SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_count RETURNS INTEGER SONAME 'my_json_udf.dll';
    CREATE FUNCTION json_version RETURNS STRING SONAME 'my_json_udf.dll';
	CREATE FUNCTION json_test_parser RETURNS string SONAME 'my_json_udf.dll';
  ELSE
    CREATE FUNCTION json_valid RETURNS integer SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_search RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_extract RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_replace RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_append RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_remove RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_set RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_merge RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_safe_merge RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_deep_merge RETURNS string SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_contains_key RETURNS integer SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_depth RETURNS INTEGER SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_count RETURNS INTEGER SONAME 'libmy_json_udf.so';
    CREATE FUNCTION json_version RETURNS STRING SONAME 'libmy_json_udf.so';
	CREATE FUNCTION json_test_parser RETURNS string SONAME 'libmy_json_udf.so';
  END IF;
END//
delimiter ;
CALL install_jsonudfs;
