/* 
  Copyright (c) 2013 - 2014, Oracle and/or its affiliates. All rights reserved.
  
  This program is free software; you can redistribute it and/or modify it under 
  the terms of the GNU General Public License as published by the Free Software 
  Foundation; version 2 of the License.
  
  This program is distributed in the hope that it will be useful, but WITHOUT ANY 
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with this 
  program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth 
  Floor, Boston, MA 02110-1301  USA
*/
#pragma once

#ifndef JKEY
#define JKEY

//#include <string.h>
//#include <stdio.h>
#include <stdlib.h>

/* 
  Key element for search functions, such as json_extract
*/
class JKey
{
public:
  virtual ~JKey() {};
  virtual char* as_string() { return NULL; };
  virtual long long as_longlong() { return 0; };
};


/* String key element */
class JKey_string: public JKey
{
private:
  char* value;
  
public:
  JKey_string(char* value);
  ~JKey_string();
  char* as_string();
  long long as_longlong();
};


/* Longlong key element */
class JKey_longlong: public JKey
{
private:
  long long value;
  
public:
  JKey_longlong(long long value);
  long long as_longlong();
};


/* Path element for JCallback_search */
struct JPath
{
  char* key;      // Found key
  bool in_array;  // Is this array element?
  int key_len;    // Length of the key
  
  JPath(char* k, int klen, bool in_arr= false): key(k), key_len(klen), in_array(in_arr) {};
  
  ~JPath()
  {
    delete[] key;
  }
};
#endif /* JKEY */

/*
* :tabSize=2:indentSize=2:noTabs=true:
* :folding=custom:collapseFolds=1:
*/
