--disable_query_log
--disable_warnings
drop table if exists json_udf_test;
--enable_warnings
create table json_udf_test(id int not null primary key, f1 text);

#valid
insert into json_udf_test values(1, '{
    "reference": {
        "title": "MySQL 5.6 Reference Manual",
		"14. Storage Engines": {
            "abbrev": "S",
			"14.2. The InnoDB Storage Engine": {
                "14.2.4. InnoDB Performance Tuning and Troubleshooting": {
                    "Tips": "14.2.4.1. InnoDB Performance Tuning Tips",
					"Enhancements": "14.2.4.2. InnoDB Performance and Scalability Enhancements",
					"I_S": "14.2.4.3. InnoDB INFORMATION_SCHEMA tables",
					"Engine": "INNODB",
					
					"INFORMATION_SCHEMA tables": {
                        "description": "The INFORMATION_SCHEMA is a MySQL feature that helps you monitor server activity to diagnose capacity and performance issues.",
						"TableList": ["INNODB_CMP", "INNODB_CMP_RESET"]
                    },
					"Monitors": "14.2.4.4. SHOW ENGINE INNODB STATUS and the InnoDB Monitors"
                }
            }
        }
    }
}

');

#valid
insert into json_udf_test values(2, '{"menu": {
  "id": "My Dream",
  "daytime": "Helsinki",
  "variation": {
    "mondaymenu": [
      {"daytime": "Breakfast", "dish": "CreateBreakfast()"},
      {"daytime": "Lunch", "dish": "CreateLunch()"},
      {"daytime": "Dinner", "dish": "CreateDinner()"}
    ]
  }
}}

');

#valid
#todo: add tests for all kinds of integers
insert into json_udf_test values(3, '{"digit": {
    "foo": "bar",
    "unsigned integer": {
        "title": "Numbers test",
        "absciss": 500,
        "ordinate": 500
    }
}}    

');

#valid
insert into json_udf_test values(4, '{
  "steps": [
    {
      "join_preparation": {
        "select#": 1,
        "steps": [
          {
            "expanded_query": "/* select#1 */ select `mysql`.`user`.`Host` AS `Host`,`mysql`.`user`.`User` AS `User`,`mysql`.`user`.`Password` AS `Password`,`mysql`.`user`.`Select_priv` AS `Select_priv`,`mysql`.`user`.`Insert_priv` AS `Insert_priv`,`mysql`.`user`.`Update_priv` AS `Update_priv`,`mysql`.`user`.`Delete_priv` AS `Delete_priv`,`mysql`.`user`.`Create_priv` AS `Create_priv`,`mysql`.`user`.`Drop_priv` AS `Drop_priv`,`mysql`.`user`.`Reload_priv` AS `Reload_priv`,`mysql`.`user`.`Shutdown_priv` AS `Shutdown_priv`,`mysql`.`user`.`Process_priv` AS `Process_priv`,`mysql`.`user`.`File_priv` AS `File_priv`,`mysql`.`user`.`Grant_priv` AS `Grant_priv`,`mysql`.`user`.`References_priv` AS `References_priv`,`mysql`.`user`.`Index_priv` AS `Index_priv`,`mysql`.`user`.`Alter_priv` AS `Alter_priv`,`mysql`.`user`.`Show_db_priv` AS `Show_db_priv`,`mysql`.`user`.`Super_priv` AS `Super_priv`,`mysql`.`user`.`Create_tmp_table_priv` AS `Create_tmp_table_priv`,`mysql`.`user`.`Lock_tables_priv` AS `Lock_tables_priv`,`mysql`.`user`.`Execute_priv` AS `Execute_priv`,`mysql`.`user`.`Repl_slave_priv` AS `Repl_slave_priv`,`mysql`.`user`.`Repl_client_priv` AS `Repl_client_priv`,`mysql`.`user`.`Create_view_priv` AS `Create_view_priv`,`mysql`.`user`.`Show_view_priv` AS `Show_view_priv`,`mysql`.`user`.`Create_routine_priv` AS `Create_routine_priv`,`mysql`.`user`.`Alter_routine_priv` AS `Alter_routine_priv`,`mysql`.`user`.`Create_user_priv` AS `Create_user_priv`,`mysql`.`user`.`Event_priv` AS `Event_priv`,`mysql`.`user`.`Trigger_priv` AS `Trigger_priv`,`mysql`.`user`.`Create_tablespace_priv` AS `Create_tablespace_priv`,`mysql`.`user`.`ssl_type` AS `ssl_type`,`mysql`.`user`.`ssl_cipher` AS `ssl_cipher`,`mysql`.`user`.`x509_issuer` AS `x509_issuer`,`mysql`.`user`.`x509_subject` AS `x509_subject`,`mysql`.`user`.`max_questions` AS `max_questions`,`mysql`.`user`.`max_updates` AS `max_updates`,`mysql`.`user`.`max_connections` AS `max_connections`,`mysql`.`user`.`max_user_connections` AS `max_user_connections`,`mysql`.`user`.`plugin` AS `plugin`,`mysql`.`user`.`authentication_string` AS `authentication_string`,`mysql`.`user`.`password_expired` AS `password_expired` from `mysql`.`user`"
          }
        ]
      }
    },
    {
      "join_optimization": {
        "select#": 1,
        "steps": [
          {
            "table_dependencies": [
              {
                "table": "`mysql`.`user`",
                "row_may_be_null": false,
                "map_bit": 0,
                "depends_on_map_bits": [
                ]
              }
            ]
          },
          {
            "rows_estimation": [
              {
                "table": "`mysql`.`user`",
                "table_scan": {
                  "rows": 4,
                  "cost": 2
                }
              }
            ]
          },
          {
            "considered_execution_plans": [
              {
                "plan_prefix": [
                ],
                "table": "`mysql`.`user`",
                "best_access_path": {
                  "considered_access_paths": [
                    {
                      "access_type": "scan",
                      "rows": 4,
                      "cost": 2.8762,
                      "chosen": true
                    }
                  ]
                },
                "cost_for_plan": 2.8762,
                "rows_for_plan": 4,
                "chosen": true
              }
            ]
          },
          {
            "attaching_conditions_to_tables": {
              "original_condition": null,
              "attached_conditions_computation": [
              ],
              "attached_conditions_summary": [
                {
                  "table": "`mysql`.`user`",
                  "attached": null
                }
              ]
            }
          },
          {
            "refine_plan": [
              {
                "table": "`mysql`.`user`",
                "access_type": "table_scan"
              }
            ]
          }
        ]
      }
    },
    {
      "join_execution": {
        "select#": 1,
        "steps": [
        ]
      }
    }
  ]
}

');

#valid
insert into json_udf_test values(5, '{"nulls": {
    "foo": "bar",
    "test": [
        {"baz": "boom"},
        {"Ann": "Bob", "cat": "dog"},
        null,
        {"Jane": "Jack", "Smith": "Ben"},
        {"Alice": "Barry", "Cindy": "Sarah"},
        {"Bond": "Street", "Harry": "Henry"},
        null,
        {"final": "End"}
    ]
}}

');

#valid
#does not work yet
insert into json_udf_test values(6, '{"menu": {
  "id": "My Dream",
  "daytime": "Helsinki",
  "variation": {
    "mondaymenu": [
      {"daytime": "Breakfast", "dish": "CreateBreakfast()"},
      {"daytime": "Lunch", "dish": "CreateLunch()"},
      {"daytime": "Dinner", "dish": "CreateDinner()"},
      {"daytime": "foo\\"bar", "dish": "foo\\bar()"},
      {"daytime": "[array]", "dish": "{object}()"}
    ]
  }
}}

');

#invalid
insert into json_udf_test values(7, '{"menu": {
  "id": "My Dream",
  "daytime": "Helsinki",
  "variation": {
    "mondaymenu": [
      {"daytime": "Breakfast", "dish": "CreateBreakfast()"},
      {"daytime": "Lunch", "dish": "CreateLunch()"},
      {"daytime": "Dinner", "dish": "CreateDinner()"},
      {"daytime": "foo\"bar", "dish": "foo\aar()"}
    ]
  }
}}

');

#invalid
insert into json_udf_test values(8, '"menu": {
  "id": "My Dream",
  "daytime": "Helsinki",
  "variation": {
    "mondaymenu": [
      {"daytime": "Breakfast", "dish": "CreateBreakfast()"},
      {"daytime": "Lunch", "dish": "CreateLunch()"},
      {"daytime": "Dinner", "dish": "CreateDinner()"},
      {"daytime": "foo\"bar", "dish": "foo\\bar()"}
    ]
  }
}}

');

#invalid
insert into json_udf_test values(9, '{"menu": {
  "id": "My Dream",
  "daytime": "Helsinki",
  "variation": {
    "mondaymenu": [
      {"daytime": "Breakfast", "dish": "CreateBreakfast()"},
      {"daytime": "Lunch", "dish": "CreateLunch()"},
      {"daytime": "Dinner", "dish": "CreateDinner()"},
      {"daytime": "foo\"bar", "dish": "foo\\bar()"}
    ]
  }
]}

');
--enable_query_log
